---
title: matrix3d()
slug: Web/CSS/transform-function/matrix3d()
tags:
  - CSS
  - CSS Function
  - CSS Transforms
  - Function
  - Reference
---
<div>{{CSSRef}}</div>

<p>The <strong><code>matrix3d()</code></strong> <a href="/en-US/docs/Web/CSS">CSS</a> <a href="/en-US/docs/Web/CSS/CSS_Functions">function</a> defines a 3D transformation as a 4x4 homogeneous matrix. Its result is a {{cssxref("&lt;transform-function&gt;")}} data type.</p>

<h2 id="Syntax">Syntax</h2>

<p>The <code>matrix3d()</code> function is specified with 16 values. They are described in the column-major order.</p>

<pre class="syntaxbox notranslate">matrix3d(<var>a1</var>, <var>b1</var>, <var>c1</var>, <var>d1</var>, <var>a2</var>, <var>b2</var>, <var>c2</var>, <var>d2</var>, <var>a3</var>, <var>b3</var>, <var>c3</var>, <var>d3</var>, <var>a4</var>, <var>b4</var>, <var>c4</var>, <var>d4</var>)</pre>

<h3 id="Values">Values</h3>

<dl>
	<dt><var>a1</var> <var>b1</var> <var>c1</var> <var>d1</var> <var>a2</var> <var>b2</var> <var>c2</var> <var>d2</var> <var>a3</var> <var>b3</var> <var>c3</var> <var>d3</var></dt>
	<dd>Are {{cssxref("&lt;number&gt;")}}s describing the linear transformation.</dd>
	<dt><var>a4</var> <var>b4</var> <var>c4 d4</var></dt>
	<dd>Are {{cssxref("&lt;number&gt;")}}s describing the translation to apply.</dd>
</dl>

<div class="note"><strong>Note:</strong> Until Firefox 16, Gecko accepted a {{cssxref("&lt;length&gt;")}} value for <var>a4</var>, <var>b4</var> and <var>c4</var>.</div>

<table class="standard-table">
	<thead>
		<tr>
			<th scope="col">Cartesian coordinates on ℝ<sup>2</sup></th>
			<th scope="col">Homogeneous coordinates on ℝℙ<sup>2</sup></th>
			<th scope="col">Cartesian coordinates on ℝ<sup>3</sup></th>
			<th scope="col">Homogeneous coordinates on ℝℙ<sup>3</sup></th>
		</tr>
	</thead>
	<tbody>
		<tr>
			<td colspan="2" rowspan="2">This transformation applies to the 3D space and can't be represented on the plane.</td>
			<td colspan="1" rowspan="2">A generic 3D <a href="https://en.wikipedia.org/wiki/Affine_transformation">affine transformation</a> can't be represented using a Cartesian-coordinate matrix, as translations are not linear transformations.</td>
			<td colspan="1" rowspan="2"><math><mfenced><mtable><mtr><mtd>a1</mtd><mtd>a2</mtd><mtd>a3</mtd><mtd>a4</mtd></mtr><mtr><mtd>b1</mtd><mtd>b2</mtd><mtd>b3</mtd><mtd>b4</mtd></mtr><mtr><mtd>c1</mtd><mtd>c2</mtd><mtd>c3</mtd><mtd>c4</mtd></mtr><mtr><mtd>d1</mtd><mtd>d2</mtd><mtd>d3</mtd><mtd>d4</mtd></mtr></mtable> </mfenced> </math></td>
		</tr>
	</tbody>
</table>

<h2 id="Examples">Examples</h2>

<h3 id="Cube_squashing_example">Cube squashing example</h3>

<p>The following example shows a 3D cube created from DOM elements and transforms, which can be hovered/focused to apply a <code>matrix3d()</code> transform to it.</p>

<h4 id="HTML">HTML</h4>

<pre class="brush: html notranslate">&lt;section id="example-element" tabindex="0"&gt;
  &lt;div class="face front"&gt;1&lt;/div&gt;
  &lt;div class="face back"&gt;2&lt;/div&gt;
  &lt;div class="face right"&gt;3&lt;/div&gt;
  &lt;div class="face left"&gt;4&lt;/div&gt;
  &lt;div class="face top"&gt;5&lt;/div&gt;
  &lt;div class="face bottom"&gt;6&lt;/div&gt;
&lt;/section&gt;
</pre>

<h4 id="CSS">CSS</h4>

<pre class="brush: css notranslate">#example-element {
  width: 100px;
  height: 100px;
  transform-style: preserve-3d;
  transition: transform 1.5s;
  transform: rotate3d(1, 1, 1, 30deg);
  margin: 50px auto;
}

#example-element:hover, #example-element:focus {
  transform: rotate3d(1, 1, 1, 30deg) matrix3d(1,0,0,0,0,1,6,0,0,0,1,0,50,100,0,1.1);
}

.face {
  display: flex;
  align-items: center;
  justify-content: center;
  width: 100%;
  height: 100%;
  position: absolute;
  backface-visibility: inherit;
  font-size: 60px;
  color: #fff;
}

.front {
    background: rgba(90,90,90,.7);
    transform: translateZ(50px);
}

.back {
    background: rgba(0,210,0,.7);
    transform: rotateY(180deg) translateZ(50px);
}

.right {
  background: rgba(210,0,0,.7);
  transform: rotateY(90deg) translateZ(50px);
}

.left {
  background: rgba(0,0,210,.7);
  transform: rotateY(-90deg) translateZ(50px);
}

.top {
  background: rgba(210,210,0,.7);
  transform: rotateX(90deg) translateZ(50px);
}

.bottom {
  background: rgba(210,0,210,.7);
  transform: rotateX(-90deg) translateZ(50px);
}</pre>

<h4 id="Result">Result</h4>

<div>{{EmbedLiveSample('Cube_squashing_example', '100%', '300px')}}</div>

<h3 id="Matrix_translation_and_scale_example">Matrix translation and scale example</h3>

<p>Another <code>transform3d()</code> example, which implements an animated combined translate and scale.</p>

<h4 id="HTML_2">HTML</h4>

<pre class="brush: html notranslate">&lt;div class="foo"&gt;
Lorem ipsum dolor sit amet, consectetur adipisicing elit.
Quos quaerat sit soluta, quisquam exercitationem delectus qui unde in facere
necessitatibus aut quia porro dolorem nesciunt enim, at consequuntur aliquam esse?
&lt;/div&gt;
</pre>

<h4 id="CSS_2">CSS</h4>

<pre class="brush: css notranslate">html {
  width: 100%;
}
body {
  height: 100vh;
  /* Centering content */
  display: flex;
  flex-flow: row wrap;
  justify-content: center;
  align-content: center;

}
.foo {
  width: 50%;
  padding: 1em;
  color: white;
  background: #ff8c66;
  border: 2px dashed black;
  text-align: center;
  font-family: system-ui, sans-serif;
  font-size: 14px;
   /* Setting up animation for better demonstration */
  animation: MotionScale 2s alternate linear infinite;
}

@keyframes MotionScale {
  from {
    /*
      Identity matrix is used as basis here.
      The matrix below describes the
      following transformations:
        Translates every X point by -50px
        Translates every Y point by -100px
        Translates every Z point by 0
        Scales down by 10%
    */
    transform: matrix3d(
      1,0,0,0,
      0,1,0,0,
      0,0,1,0,
      -50,-100,0,1.1
    );

  }
  50% {
    transform: matrix3d(
      1,0,0,0,
      0,1,0,0,
      0,0,1,0,
      0,0,0,0.9
    );
  }
  to {
     transform: matrix3d(
      1,0,0,0,
      0,1,0,0,
      0,0,1,0,
      50,100,0,1.1
    )
  }
}</pre>

<h4 id="Result_2">Result</h4>

<div>{{EmbedLiveSample('Matrix_translation_and_scale_example', '100%', '400px')}}</div>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
	<thead>
		<tr>
			<th scope="col">Specification</th>
			<th scope="col">Status</th>
			<th scope="col">Comment</th>
		</tr>
	</thead>
	<tbody>
		<tr>
			<td>{{SpecName("CSS Transforms 2", "#funcdef-matrix3d", "matrix3d()")}}</td>
			<td>{{Spec2("CSS Transforms 2")}}</td>
			<td>Initial definition</td>
		</tr>
	</tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("css.types.transform-function")}}</p>

<h2 id="See_also">See also</h2>

<ul>
	<li>{{cssxref("transform")}}</li>
	<li>{{cssxref("&lt;transform-function&gt;")}}</li>
	<li><a href="https://dev.opera.com/articles/understanding-the-css-transforms-matrix/">Understanding the CSS Transforms Matrix</a></li>
</ul>
